/*
 * main.vala is a part of snul
 *
 * Snul: is a simple library that implements
 *       a tcp socket client in vala
 *
 * Copyright (C) 2008  Andrea Del Signore
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 *
 * Author:
 *     Andrea Del Signore <sejerpz@tin.it>
 */

#ifndef __SRC_MAIN_H__
#define __SRC_MAIN_H__

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS


#define SOCKET_TYPE_MAIN (socket_main_get_type ())
#define SOCKET_MAIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOCKET_TYPE_MAIN, SocketMain))
#define SOCKET_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOCKET_TYPE_MAIN, SocketMainClass))
#define SOCKET_IS_MAIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOCKET_TYPE_MAIN))
#define SOCKET_IS_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOCKET_TYPE_MAIN))
#define SOCKET_MAIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOCKET_TYPE_MAIN, SocketMainClass))

typedef struct _SocketMain SocketMain;
typedef struct _SocketMainClass SocketMainClass;
typedef struct _SocketMainPrivate SocketMainPrivate;

struct _SocketMain {
	GObject parent_instance;
	SocketMainPrivate * priv;
};
struct _SocketMainClass {
	GObjectClass parent_class;
};

SocketMain* socket_main_new (void);
void socket_main_run (SocketMain* self);
GType socket_main_get_type (void);

G_END_DECLS

#endif
